# ---------------------------------------------------------------------------
# prekazky_skript.py
# Created on: 2011-11-03 11:39:26.00000
#   (generated by ArcGIS/ModelBuilder)
# Description: Skript pro nalezeni prekazek ve vodnich tocich na zaklade terenu leteckeho laseroveho skenovani (LLS).
# Vstupy: osa vodniho toku (1 linie), teren ve forme terrain LLS, rozestup vrcholu linie - ovlivnuje presnost polohy, minimalni spad prekazky pro volitelnou selekci. 

# Autor: Katerina Uhlirova, Vyzkumny ustav vodohospodarsky, v.v.i.
# ---------------------------------------------------------------------------

# Set the necessary product code
# import arcinfo


# Import arcpy module
import arcpy, sys, math, string
arcpy.env.workspace = sys.argv[1]
address_locator = arcpy.env.workspace
# Check out any necessary licenses
arcpy.CheckOutExtension("3D")

# Load required toolboxes
#arcpy.ImportToolbox("E:/data/1_VZ/2011/prekazky.tbx")
def VypisHlasku (text):
    print (text)
    arcpy.AddMessage(text)

# Local variables:
# nacteni dat
vstup_osa = sys.argv[2]
vstup_terrain = sys.argv[3]
vystup_body = sys.argv[4]
vstup_rozestup = sys.argv[5]
vstup_selection = sys.argv[6]
#vstup_symbology = sys.argv[7]


# Process: Copy/Make a layer from the feature class
# Set overwrite option
# arcpy.OverWriteOutput = True

vystup_osa= string.replace(vstup_osa, ".shp", "_"+vstup_rozestup+".shp")

if arcpy.Exists(vystup_osa):
    arcpy.Delete_management(vystup_osa)
    VypisHlasku(vystup_osa+" bude nahrazena novou vrstvou.")
arcpy.CopyFeatures_management(vstup_osa,vystup_osa)
arcpy.MakeFeatureLayer_management(vystup_osa,"osa_tmp")

# Process: Densify
arcpy.gp.Densify("osa_tmp", "DISTANCE", vstup_rozestup, "", "")

# Process: Feature Vertices To Points
arcpy.FeatureVerticesToPoints_management("osa_tmp", vystup_body, "ALL")

# Process: Add XY Coordinates
arcpy.AddXY_management(vystup_body)

# Process: Add Field (1)
arcpy.AddField_management(vystup_body, "KM", "DOUBLE", "0", "0", "", "", "NULLABLE", "NON_REQUIRED", "")

# Process: Add Surface Information
arcpy.AddSurfaceInformation_3d(vystup_body, vstup_terrain, "Z", "LINEAR", "", "1", "0")

# Process: Add Field (2)
arcpy.AddField_management(vystup_body, "MIN", "DOUBLE", "0", "0", "", "", "NULLABLE", "NON_REQUIRED", "")
# Process: Add Field (3)
arcpy.AddField_management(vystup_body, "ROZDIL", "DOUBLE", "0", "0", "", "", "NULLABLE", "NON_REQUIRED", "")
# Process: Add Field (4)
arcpy.AddField_management(vystup_body, "SOUCET", "DOUBLE", "0", "0", "", "", "NULLABLE", "NON_REQUIRED", "")
# Process: Add Field (5)
arcpy.AddField_management(vystup_body, "STUPEN", "DOUBLE", "0", "0", "", "", "NULLABLE", "NON_REQUIRED", "")
# Process: Add Field (6)
arcpy.AddField_management(vystup_body, "DELKA", "DOUBLE", "0", "0", "", "", "NULLABLE", "NON_REQUIRED", "")

# ORIENTACE
VypisHlasku("\nZjistuji orientaci toku")
cur = arcpy.UpdateCursor(vystup_body)
n = 0
Z1 = 0
Z2 = 0
for row in cur:
    if n == 0:
        Z1 = row.Z
    else:
        Z2 = row.Z
    n = n+1
n = 0
VypisHlasku("Z1 je "+str(Z1)+" Z2 je "+str(Z2))
if Z1 < Z2: # je to obracene
    cur = arcpy.UpdateCursor(vystup_body,"","","","FID D")
    for row in cur:
        row.OBJECTID = n
        cur.updateRow(row)
        n = n+1
    VypisHlasku("orientace je opacna - zdola nahoru")
else:
    VypisHlasku("orientace je v poradku - shora dolu")
# MINIMUM, KM, OBJECTID
VypisHlasku("\nPocitam minimum a prumerny sklon")
cur = arcpy.UpdateCursor(vystup_body,"","","","OBJECTID A")           #projizdi tok odshora - po toku
n = 0
min1 = 0
km = 0
x = 0
y = 0
for row in cur:
    #MINIMUM pro 1. radek
    if n == 0:
        row.MIN = row.Z
        min1 = row.MIN
        Z_max = min1
        row.KM = 0
    #MINIMUM pro ostatni radky    
    else:
        #MINIMUM
        if row.Z < min1:
            row.MIN = row.Z
        else:
            row.MIN = min1
        # KM
        row.KM = km + math.sqrt((row.POINT_X - x)**2+(row.POINT_Y - y)**2)
    # X, Y, KM
    x = row.POINT_X
    y = row.POINT_Y
    km = row.KM
    row.OBJECTID = n
    cur.updateRow(row)
    min1 = row.MIN
    n = n+1  
del cur, row
Z_min = min1
delka_toku= float(km)
Z_prum = float((Z_max-Z_min)/(delka_toku)*100)   #vstup_rozestup
VypisHlasku("Z_max je " + str(Z_max) + "\n" + "Z_min je " + str(Z_min) + "\n"+ "Delka toku je " + str(delka_toku) + "\n" + "prumerny sklon je " + str(Z_prum) + "%.")
#ROZDIL, SOUCET, DELKA

VypisHlasku("\nPocitam rozdil, soucet a delku")
cur = arcpy.UpdateCursor(vystup_body,"","","","OBJECTID D")     #projizdi tok odspodu - proti toku
soucet = 0
skok = 0
pripad = 0
delka = 0
n = 0 
for row in cur:
    if n == 0:
        row.ROZDIL = 0
        #row.SKLON = 0
        row.SOUCET = 0
        row.STUPEN = 0
        min1 = row.MIN
        n = n+1
    else:
        #ROZDIL
        row.ROZDIL = row.MIN - min1
        min1 = row.MIN
    # STUPEN, DELKA
    if (row.ROZDIL > 0.1 and skok == 1):      # STUPEN, pripocit
        pripad = 1
        row.SOUCET = row.ROZDIL + soucet
        soucet = row.SOUCET
        delka = delka +1
    elif (row.ROZDIL > 0.1 and skok == 0):    # konci STUPEN, pripocit
        pripad = 2
        row.SOUCET = row.ROZDIL + soucet
        soucet = row.SOUCET
        skok = 1
        delka = delka +1
    elif (row.ROZDIL <= 0.1 and skok == 1):    # pred zacatkem STUPNE, zrusit soucet, zapsat delku
        pripad = 3
        row.SOUCET = 0
        celk_delka = delka* float(vstup_rozestup)
        row.DELKA = celk_delka             # vzdalenost bodu - 5 m 
        #VypisHlasku("delka stupne je " + str(delka)+ "celk delka " + str(celk_delka))
        delka = 0
        soucet = 0
        skok = 0
    else:                               # neni stupen ani zmena
        pripad = 4
        row.SOUCET = 0
    cur.updateRow(row)
    print pripad, delka
del cur, row
#STUPEN, DELKA posun
VypisHlasku("\nPocitam stupen a posouvam delku")
cur = arcpy.UpdateCursor(vystup_body,"","","","OBJECTID A")       #projizdi tok odshora - po toku
soucet = 0
delka = 0
for row in cur:
    if (row.SOUCET > soucet):               # STUPEN, pripocit
        row.STUPEN = row.SOUCET         
        soucet = row.SOUCET
    else:
        row.STUPEN = 0
        soucet = row.SOUCET
    # DELKA posun o 1 dolu
    if (row.DELKA > 0):
        delka = row.DELKA
        row.DELKA = 0
    elif (delka > 0):
        row.DELKA = delka
        delka = 0    
    cur.updateRow(row)
del cur, row
if vstup_selection > 0:
    VypisHlasku("\nVytvarim selekci")

# Make a layer from the feature class
    arcpy.MakeFeatureLayer_management(vystup_body, "lyr")

#VypisHlasku("\nPrirazuji symbologii")
# Process: Apply Symbology From Layer
#arcpy.ApplySymbologyFromLayer_management("lyr", vstup_symbology)

    SelCondition = "STUPEN >"+str(vstup_selection)

# Within selected features, further select only those points which have a STUPEN > vstup_selection   
    arcpy.SelectLayerByAttribute_management("lyr", "NEW_SELECTION",SelCondition)

    spad=string.replace(vstup_selection,".","")
    vystup_sel= string.replace(vystup_body, ".shp", "_"+str(vstup_rozestup)+"_"+spad+".shp")

# Write the selected features to a new featureclass
    arcpy.CopyFeatures_management("lyr",vystup_sel)
    VypisHlasku("\nVrstva prekazek s minimalnim spadem "+vstup_selection+" m je ulozena ve Vasem pocitaci.")
else:
    VypisHlasku("\nNebyl zadan minimalni spad prekazky pro selekci, selekce nebyla vytvorena.")


VypisHlasku("\nHotovo :)")

# Execute DeleteField to delete all fields in the field list. 
# arcpy.DeleteField_management(updatedTable, fieldNameList)


